"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RECOMMENDED_PORTS_BY_PROTOCOL = exports.VALID_PROTOCOLS = exports.VALID_OUTPUT_MODES = exports.DEFAULT_CONFIG = exports.CONFIG_FILE_PATH = exports.USER_HOME_DIR = void 0;
var path_1 = require("path");
var os_1 = require("os");
// Path to user's home directory
var USER_HOME_DIR = (0, os_1.homedir)();
exports.USER_HOME_DIR = USER_HOME_DIR;
// Path to the config file
var CONFIG_FILE_PATH = (0, path_1.join)(USER_HOME_DIR, '.mqttx-cli', 'config');
exports.CONFIG_FILE_PATH = CONFIG_FILE_PATH;
// Default configuration
var DEFAULT_CONFIG = {
    output: 'text',
    mqtt: {
        host: 'localhost',
        port: 1883,
        protocol: 'mqtt',
        maxReconnectTimes: 10,
    },
};
exports.DEFAULT_CONFIG = DEFAULT_CONFIG;
var VALID_OUTPUT_MODES = ['text', 'log'];
exports.VALID_OUTPUT_MODES = VALID_OUTPUT_MODES;
var VALID_PROTOCOLS = ['mqtt', 'mqtts', 'ws', 'wss'];
exports.VALID_PROTOCOLS = VALID_PROTOCOLS;
var RECOMMENDED_PORTS_BY_PROTOCOL = {
    mqtt: 1883,
    mqtts: 8883,
    ws: 8083,
    wss: 8084,
};
exports.RECOMMENDED_PORTS_BY_PROTOCOL = RECOMMENDED_PORTS_BY_PROTOCOL;
