"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Commander = void 0;
require("core-js");
var commander_1 = require("commander");
var generator_1 = require("./utils/generator");
var checkUpdate_1 = require("./utils/checkUpdate");
var parse_1 = require("./utils/parse");
var conn_1 = require("./lib/conn");
var pub_1 = require("./lib/pub");
var sub_1 = require("./lib/sub");
var ls_1 = __importDefault(require("./lib/ls"));
var init_1 = require("./lib/init");
var package_json_1 = require("../package.json");
var state_1 = __importDefault(require("./state"));
var Commander = /** @class */ (function () {
    function Commander() {
        this.program = new commander_1.Command();
    }
    Commander.prototype.init = function () {
        var _this = this;
        this.program
            .name('mqttx')
            .description('An MQTT client for the command line')
            .enablePositionalOptions()
            .allowUnknownOption(false)
            .version("".concat(package_json_1.version, "\nhttps://mqttx.app/changelogs/v").concat(package_json_1.version), '-v, --version');
        this.program
            .command('check')
            .description('Check for updates.')
            .allowUnknownOption(false)
            .hook('preAction', function (thisCommand) {
            globalThis.command = thisCommand;
        })
            .action(function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, (0, checkUpdate_1.checkUpdate)()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        this.program
            .command('init')
            .description('Initialize the configuration file.')
            .allowUnknownOption(false)
            .hook('preAction', function (thisCommand) {
            globalThis.command = thisCommand;
        })
            .action(init_1.initConfig);
        this.program
            .command('conn')
            .description('Create a connection and connect to MQTT Broker.')
            .option('-V, --mqtt-version <5.0/3.1.1/3.1>', 'the MQTT version', parse_1.parseMQTTVersion, 5)
            .option('-h, --hostname <HOST>', 'the broker host', state_1.default.getConfig('host'))
            .option('-p, --port <PORT>', 'the broker port', parse_1.parseNumber, state_1.default.getConfig('port'))
            .option('-i, --client-id <ID>', 'the client id', (0, generator_1.getClientId)())
            .option('--no-clean', 'set the clean session flag to false', true)
            .option('-k, --keepalive <SEC>', 'send a ping every SEC seconds', parse_1.parseNumber, 30)
            .option('-u, --username <USER>', 'the username', state_1.default.getConfig('username'))
            .option('-P, --password <PASS>', 'the password', state_1.default.getConfig('password'))
            .option('-l, --protocol <PROTO>', 'the protocol to use, mqtt, mqtts, ws, or wss', parse_1.parseProtocol, state_1.default.getConfig('protocol'))
            .option('--path <PATH>', 'the path of websocket', '/mqtt')
            .option('-wh, --ws-headers <WSHEADERS...>', 'headers for WebSocket options (only works with MQTT over WebSocket connections, e.g. -wh "Authorization: Bearer token")', parse_1.parseKeyValues)
            .option('--key <PATH>', 'path to the key file')
            .option('--cert <PATH>', 'path to the cert file')
            .option('--ca <PATH>', 'path to the ca certificate')
            .option('--insecure', 'do not verify the server certificate')
            .option('--alpn <PROTO...>', 'set one or multiple ALPN (Application Layer Protocol Negotiation) protocols')
            .option('-rp, --reconnect-period <MILLISECONDS>', 'interval between two reconnections, disable auto reconnect by setting to 0', parse_1.parseNumber, 1000)
            .option('--maximum-reconnect-times <NUMBER>', 'the maximum reconnect times', parse_1.parseNumber, state_1.default.getConfig('maxReconnectTimes'))
            // properties options of MQTT 5.0
            .option('-se, --session-expiry-interval <SECONDS>', 'the session expiry interval in seconds', parse_1.parseNumber)
            .option('--rcv-max, --receive-maximum <NUMBER>', 'the receive maximum value', parse_1.parseNumber)
            .option('--maximum-packet-size <NUMBER>', 'the maximum packet size the client is willing to accept', parse_1.parseNumber)
            .option('--topic-alias-maximum <NUMBER>', 'the topic alias maximum value', parse_1.parseNumber)
            .option('--req-response-info', 'the client requests response information from the server')
            .option('--no-req-problem-info', 'the client requests problem information from the server')
            .option('-up, --user-properties <USERPROPERTIES...>', 'the user properties of MQTT 5.0 (e.g. -up "name: mqttx cli")', parse_1.parseKeyValues)
            // will message options
            .option('-Wt, --will-topic <TOPIC>', 'the will topic')
            .option('-Wm, --will-message <BODY>', 'the will message')
            .option('-Wq, --will-qos <0/1/2>', 'the will qos', parse_1.parseNumber)
            .option('-Wr, --will-retain', 'send a will retained message')
            // will message properties options of MQTT 5.0
            .option('-Wd, --will-delay-interval <SECONDS>', 'the will delay interval in seconds', parse_1.parseNumber)
            .option('-Wpf, --will-payload-format-indicator', 'will message is UTF-8 encoded character data or not')
            .option('-We, --will-message-expiry-interval <SECONDS>', 'lifetime of the will message in seconds', parse_1.parseNumber)
            .option('-Wct, --will-content-type <CONTENTTYPE>', 'description of the will message’s content')
            .option('-Wrt, --will-response-topic <TOPIC>', 'topic name for a response message')
            .option('-Wcd, --will-correlation-data <DATA>', 'correlation data for the response message')
            .option('-Wup, --will-user-properties <USERPROPERTIES...>', 'the user properties of will message', parse_1.parseKeyValues)
            .option('-so, --save-options [PATH]', 'save the parameters to the local configuration file, which supports json and yaml format, default path is ./mqttx-cli-options.json')
            .option('-lo, --load-options [PATH]', 'load the parameters from the local configuration file, which supports json and yaml format, default path is ./mqttx-cli-options.json')
            .option('--debug', 'enable debug mode for MQTT.js', false)
            .allowUnknownOption(false)
            .hook('preAction', function (thisCommand) {
            globalThis.command = thisCommand;
        })
            .action(conn_1.conn);
        this.program
            .command('pub')
            .description('Publish a message to a topic.')
            .option('-t, --topic <TOPIC>', 'the message topic', parse_1.parsePubTopic)
            .option('-m, --message <BODY>', 'the message body', 'Hello From MQTTX CLI')
            .option('-q, --qos <0/1/2>', 'the QoS of the message', parse_1.parseNumber, 0)
            .option('-r, --retain', 'send a retained message')
            .option('-d, --dup', 'mark as duplicate flag')
            .option('-s, --stdin', 'read the message body from stdin')
            .option('-M, --multiline', 'read lines from stdin as multiple messages')
            .option('-lm, --line-mode', 'enter interactive mode to send messages line by line (equivalent to -s -M)', false)
            // properties options of MQTT 5.0
            .option('-pf, --payload-format-indicator', 'the payload format indicator of the publish message')
            .option('-e, --message-expiry-interval <NUMBER>', 'the lifetime of the publish message in seconds', parse_1.parseNumber)
            .option('-ta, --topic-alias <NUMBER>', 'value that is used to identify the topic instead of using the topic name', parse_1.parseNumber)
            .option('-rt, --response-topic <TOPIC>', 'string which is used as the topic name for a response message')
            .option('-cd, --correlation-data <DATA>', 'used by the sender of the request message to identify which request the response message is for when it is received')
            .option('-up, --user-properties <USERPROPERTIES...>', 'the user properties of MQTT 5.0 (e.g. -up "name: mqttx cli")', parse_1.parseKeyValues)
            .option('-si, --subscription-identifier <NUMBER>', 'the identifier of the subscription', parse_1.parseNumber)
            .option('-ct, --content-type <TYPE>', 'a description of the content of the publish message')
            // connect options
            .option('-V, --mqtt-version <5.0/3.1.1/3.1>', 'the MQTT version', parse_1.parseMQTTVersion, 5)
            .option('-h, --hostname <HOST>', 'the broker host', state_1.default.getConfig('host'))
            .option('-p, --port <PORT>', 'the broker port', parse_1.parseNumber, state_1.default.getConfig('port'))
            .option('-f, --format <TYPE>', 'the format type of the input message, support base64, json, hex, binary, cbor and msgpack', parse_1.parseFormat)
            .option('-i, --client-id <ID>', 'the client id', (0, generator_1.getClientId)())
            .option('--no-clean', 'set the clean session flag to false', true)
            .option('-k, --keepalive <SEC>', 'send a ping every SEC seconds', parse_1.parseNumber, 30)
            .option('-u, --username <USER>', 'the username', state_1.default.getConfig('username'))
            .option('-P, --password <PASS>', 'the password', state_1.default.getConfig('password'))
            .option('-l, --protocol <PROTO>', 'the protocol to use, mqtt, mqtts, ws, or wss', parse_1.parseProtocol, state_1.default.getConfig('protocol'))
            .option('--path <PATH>', 'the path of websocket', '/mqtt')
            .option('-wh, --ws-headers <WSHEADERS...>', 'headers for WebSocket options (only works with MQTT over WebSocket connections, e.g. -wh "Authorization: Bearer token")', parse_1.parseKeyValues)
            .option('--key <PATH>', 'path to the key file')
            .option('--cert <PATH>', 'path to the cert file')
            .option('--ca <PATH>', 'path to the ca certificate')
            .option('--insecure', 'do not verify the server certificate')
            .option('--alpn <PROTO...>', 'set one or multiple ALPN (Application Layer Protocol Negotiation) protocols')
            .option('-rp, --reconnect-period <MILLISECONDS>', 'interval between two reconnections, disable auto reconnect by setting to 0', parse_1.parseNumber, 1000)
            .option('--maximum-reconnect-times <NUMBER>', 'the maximum reconnect times', parse_1.parseNumber, state_1.default.getConfig('maxReconnectTimes'))
            // connect properties options of MQTT 5.0
            .option('-se, --session-expiry-interval <SECONDS>', 'the session expiry interval in seconds', parse_1.parseNumber)
            .option('--rcv-max, --receive-maximum <NUMBER>', 'the receive maximum value', parse_1.parseNumber)
            .option('--maximum-packet-size <NUMBER>', 'the maximum packet size the client is willing to accept', parse_1.parseNumber)
            .option('--topic-alias-maximum <NUMBER>', 'the topic alias maximum value', parse_1.parseNumber)
            .option('--req-response-info', 'the client requests response information from the server')
            .option('--no-req-problem-info', 'the client requests problem information from the server')
            .option('-Cup, --conn-user-properties <USERPROPERTIES...>', 'the connect user properties of MQTT 5.0 (e.g. -Cup "name: mqttx cli")', parse_1.parseKeyValues)
            // will message options
            .option('-Wt, --will-topic <TOPIC>', 'the will topic')
            .option('-Wm, --will-message <BODY>', 'the will message')
            .option('-Wq, --will-qos <0/1/2>', 'the will qos', parse_1.parseNumber)
            .option('-Wr, --will-retain', 'send a will retained message')
            // will message properties options of MQTT 5.0
            .option('-Wd, --will-delay-interval <SECONDS>', 'the will delay interval in seconds', parse_1.parseNumber)
            .option('-Wpf, --will-payload-format-indicator', 'will message is UTF-8 encoded character data or not')
            .option('-We, --will-message-expiry-interval <SECONDS>', 'lifetime of the will message in seconds', parse_1.parseNumber)
            .option('-Wct, --will-content-type <CONTENTTYPE>', 'description of the will message’s content')
            .option('-Wrt, --will-response-topic <TOPIC>', 'topic name for a response message')
            .option('-Wcd, --will-correlation-data <DATA>', 'correlation data for the response message')
            .option('-Wup, --will-user-properties <USERPROPERTIES...>', 'the user properties of will message', parse_1.parseKeyValues)
            .option('-so, --save-options [PATH]', 'save the parameters to the local configuration file, which supports json and yaml format, default path is ./mqttx-cli-options.json')
            .option('-lo, --load-options [PATH]', 'load the parameters from the local configuration file, which supports json and yaml format, default path is ./mqttx-cli-options.json')
            .option('--file-read <PATH>', 'read the message body from the file', parse_1.parseFileRead)
            .option('-Pp, --protobuf-path <PATH>', 'the path to the .proto file that defines the message format for Protocol Buffers (protobuf)')
            .option('-Pmn, --protobuf-message-name <NAME>', 'the name of the protobuf message type (must exist in the .proto file)')
            .option('-Ap, --avsc-path <PATH>', 'the path to the .avsc file that defines the avro schema for AVRO encoding', parse_1.parseFileRead)
            .option('--debug', 'enable debug mode for MQTT.js', false)
            .allowUnknownOption(false)
            .hook('preAction', function (thisCommand) {
            globalThis.command = thisCommand;
        })
            .action(pub_1.pub);
        this.program
            .command('sub')
            .description('Subscribes to one or more topics.')
            .option('-t, --topic <TOPIC...>', 'the message topic')
            .option('-q, --qos <0/1/2...>', 'the QoS of the message', parse_1.parseQoS)
            // properties options of MQTT 5.0
            .option('-nl, --no_local [FLAG...]', 'the no local MQTT 5.0 flag', parse_1.parseVariadicOfBooleanType)
            .option('-rap, --retain-as-published [FLAG...]', 'the retain as published MQTT 5.0 flag', parse_1.parseVariadicOfBooleanType)
            .option('-rh, --retain-handling <0/1/2...>', 'the retain handling MQTT 5.0', parse_1.parseQoS)
            .option('-si, --subscription-identifier <NUMBER...>', 'the identifier of the subscription', parse_1.parseNumber)
            .option('-up, --user-properties <USERPROPERTIES...>', 'the user properties of MQTT 5.0 (e.g. -up "name: mqttx cli")', parse_1.parseKeyValues)
            .option('-f, --format <TYPE>', 'format the message body, support base64, json, hex, binary, cbor and msgpack', parse_1.parseFormat)
            .option('-v, --verbose', 'turn on verbose mode to display incoming MQTT packets')
            .option('--output-mode <default/clean>', 'choose between the default and clean mode, which outputs the complete MQTT packet data, allowing users to pipe the output as they wish', parse_1.parseOutputMode, 'default')
            // connect options
            .option('-V, --mqtt-version <5.0/3.1.1/3.1>', 'the MQTT version', parse_1.parseMQTTVersion, 5)
            .option('-h, --hostname <HOST>', 'the broker host', state_1.default.getConfig('host'))
            .option('-p, --port <PORT>', 'the broker port', parse_1.parseNumber, state_1.default.getConfig('port'))
            .option('-i, --client-id <ID>', 'the client id', (0, generator_1.getClientId)())
            .option('--no-clean', 'set the clean session flag to false', true)
            .option('-u, --username <USER>', 'the username', state_1.default.getConfig('username'))
            .option('-P, --password <PASS>', 'the password', state_1.default.getConfig('password'))
            .option('-l, --protocol <PROTO>', 'the protocol to use, mqtt, mqtts, ws, or wss', parse_1.parseProtocol, state_1.default.getConfig('protocol'))
            .option('--path <PATH>', 'the path of websocket', '/mqtt')
            .option('-wh, --ws-headers <WSHEADERS...>', 'headers for WebSocket options (only works with MQTT over WebSocket connections, e.g. -wh "Authorization: Bearer token")', parse_1.parseKeyValues)
            .option('--key <PATH>', 'path to the key file')
            .option('--cert <PATH>', 'path to the cert file')
            .option('--ca <PATH>', 'path to the ca certificate')
            .option('--insecure', 'do not verify the server certificate')
            .option('--alpn <PROTO...>', 'set one or multiple ALPN (Application Layer Protocol Negotiation) protocols')
            .option('-rp, --reconnect-period <MILLISECONDS>', 'interval between two reconnections, disable auto reconnect by setting to 0', parse_1.parseNumber, 1000)
            .option('--maximum-reconnect-times <NUMBER>', 'the maximum reconnect times', parse_1.parseNumber, state_1.default.getConfig('maxReconnectTimes'))
            // connect properties options of MQTT 5.0
            .option('-se, --session-expiry-interval <SECONDS>', 'the session expiry interval in seconds', parse_1.parseNumber)
            .option('--rcv-max, --receive-maximum <NUMBER>', 'the receive maximum value', parse_1.parseNumber)
            .option('--maximum-packet-size <NUMBER>', 'the maximum packet size the client is willing to accept', parse_1.parseNumber)
            .option('--topic-alias-maximum <NUMBER>', 'the topic alias maximum value', parse_1.parseNumber)
            .option('--req-response-info', 'the client requests response information from the server')
            .option('--no-req-problem-info', 'the client requests problem information from the server')
            .option('-Cup, --conn-user-properties <USERPROPERTIES...>', 'the connect user properties of MQTT 5.0 (e.g. -Cup "name: mqttx cli")', parse_1.parseKeyValues)
            // will message options
            .option('-Wt, --will-topic <TOPIC>', 'the will topic')
            .option('-Wm, --will-message <BODY>', 'the will message')
            .option('-Wq, --will-qos <0/1/2>', 'the will qos', parse_1.parseNumber)
            .option('-Wr, --will-retain', 'send a will retained message')
            // will message properties options of MQTT 5.0
            .option('-Wd, --will-delay-interval <SECONDS>', 'the will delay interval in seconds', parse_1.parseNumber)
            .option('-Wpf, --will-payload-format-indicator', 'will message is UTF-8 encoded character data or not')
            .option('-We, --will-message-expiry-interval <SECONDS>', 'lifetime of the will message in seconds', parse_1.parseNumber)
            .option('-Wct, --will-content-type <CONTENTTYPE>', 'description of the will message’s content')
            .option('-Wrt, --will-response-topic <TOPIC>', 'topic name for a response message')
            .option('-Wcd, --will-correlation-data <DATA>', 'correlation data for the response message')
            .option('-Wup, --will-user-properties <USERPROPERTIES...>', 'the user properties of will message', parse_1.parseKeyValues)
            .option('-so, --save-options [PATH]', 'save the parameters to the local configuration file, which supports json and yaml format, default path is ./mqttx-cli-options.json')
            .option('-lo, --load-options [PATH]', 'load the parameters from the local configuration file, which supports json and yaml format, default path is ./mqttx-cli-options.json')
            // https://github.com/tj/commander.js/blob/master/examples/options-conflicts.js
            .addOption(new commander_1.Option('--file-write <PATH>', 'append received messages to a specified file')
            .argParser(parse_1.parseFileWrite)
            .conflicts('fileSave'))
            .addOption(new commander_1.Option('--file-save <PATH>', 'save each received message to a new file')
            .argParser(parse_1.parseFileSave)
            .conflicts('fileWrite'))
            .option('--delimiter [CHARACTER]', 'append a delimiter to the end of each message, default is "\\n"')
            .option('-Pp, --protobuf-path <PATH>', 'the path to the .proto file that defines the message format for Protocol Buffers (protobuf)')
            .option('-Pmn, --protobuf-message-name <NAME>', 'the name of the protobuf message type (must exist in the .proto file)')
            .option('-Ap, --avsc-path <PATH>', 'the path to the .avsc file that defines the avro schema for AVRO decoding', parse_1.parseFileRead)
            .option('--debug', 'enable debug mode for MQTT.js', false)
            .allowUnknownOption(false)
            .hook('preAction', function (thisCommand) {
            globalThis.command = thisCommand;
        })
            .action(sub_1.sub);
        var benchCmd = this.program.command('bench').description('MQTT Benchmark in performance testing.');
        benchCmd
            .command('conn')
            .description('Create a custom number of connections.')
            .option('-c, --count <NUMBER>', 'the number of connections', parse_1.parseNumber, 1000)
            .option('-i, --interval <MILLISECONDS>', 'interval of connecting to the broker', parse_1.parseNumber, 10)
            .option('-V, --mqtt-version <5.0/3.1.1/3.1>', 'the MQTT version', parse_1.parseMQTTVersion, 5)
            .option('-h, --hostname <HOST>', 'the broker host', state_1.default.getConfig('host'))
            .option('-p, --port <PORT>', 'the broker port', parse_1.parseNumber, state_1.default.getConfig('port'))
            .option('-I, --client-id <ID>', 'the client id, support %i (index) variable', (0, generator_1.getClientId)())
            .option('--no-clean', 'set the clean session flag to false', true)
            .option('-k, --keepalive <SEC>', 'send a ping every SEC seconds', parse_1.parseNumber, 30)
            .option('-u, --username <USER>', 'the username', state_1.default.getConfig('username'))
            .option('-P, --password <PASS>', 'the password', state_1.default.getConfig('password'))
            .option('-l, --protocol <PROTO>', 'the protocol to use, mqtt, mqtts, ws, or wss', parse_1.parseProtocol, state_1.default.getConfig('protocol'))
            .option('--path <PATH>', 'the path of websocket', '/mqtt')
            .option('-wh, --ws-headers <WSHEADERS...>', 'headers for WebSocket options (only works with MQTT over WebSocket connections, e.g. -wh "Authorization: Bearer token")', parse_1.parseKeyValues)
            .option('--key <PATH>', 'path to the key file')
            .option('--cert <PATH>', 'path to the cert file')
            .option('--ca <PATH>', 'path to the ca certificate')
            .option('--insecure', 'do not verify the server certificate')
            .option('--alpn <PROTO...>', 'set one or multiple ALPN (Application Layer Protocol Negotiation) protocols')
            .option('-rp, --reconnect-period <MILLISECONDS>', 'interval between two reconnections, disable auto reconnect by setting to 0', parse_1.parseNumber, 1000)
            .option('--maximum-reconnect-times <NUMBER>', 'the maximum reconnect times', parse_1.parseNumber, state_1.default.getConfig('maxReconnectTimes'))
            // properties options of MQTT 5.0
            .option('-se, --session-expiry-interval <SECONDS>', 'the session expiry interval in seconds', parse_1.parseNumber)
            .option('--rcv-max, --receive-maximum <NUMBER>', 'the receive maximum value', parse_1.parseNumber)
            .option('--maximum-packet-size <NUMBER>', 'the maximum packet size the client is willing to accept', parse_1.parseNumber)
            .option('--topic-alias-maximum <NUMBER>', 'the topic alias maximum value', parse_1.parseNumber)
            .option('--req-response-info', 'the client requests response information from the server')
            .option('--no-req-problem-info', 'the client requests problem information from the server')
            .option('-up, --user-properties <USERPROPERTIES...>', 'the user properties of MQTT 5.0 (e.g. -up "name: mqttx cli")', parse_1.parseKeyValues)
            // will message options
            .option('-Wt, --will-topic <TOPIC>', 'the will topic')
            .option('-Wm, --will-message <BODY>', 'the will message')
            .option('-Wq, --will-qos <0/1/2>', 'the will qos', parse_1.parseNumber)
            .option('-Wr, --will-retain', 'send a will retained message')
            // will message properties options of MQTT 5.0
            .option('-Wd, --will-delay-interval <SECONDS>', 'the will delay interval in seconds', parse_1.parseNumber)
            .option('-Wpf, --will-payload-format-indicator', 'will message is UTF-8 encoded character data or not')
            .option('-We, --will-message-expiry-interval <SECONDS>', 'lifetime of the will message in seconds', parse_1.parseNumber)
            .option('-Wct, --will-content-type <CONTENTTYPE>', 'description of the will message’s content')
            .option('-Wrt, --will-response-topic <TOPIC>', 'topic name for a response message')
            .option('-Wcd, --will-correlation-data <DATA>', 'correlation data for the response message')
            .option('-Wup, --will-user-properties <USERPROPERTIES...>', 'the user properties of will message', parse_1.parseKeyValues)
            .option('-so, --save-options [PATH]', 'save the parameters to the local configuration file, which supports json and yaml format, default path is ./mqttx-cli-options.json')
            .option('-lo, --load-options [PATH]', 'load the parameters from the local configuration file, which supports json and yaml format, default path is ./mqttx-cli-options.json')
            .allowUnknownOption(false)
            .hook('preAction', function (thisCommand) {
            globalThis.command = thisCommand;
        })
            .action(conn_1.benchConn);
        benchCmd
            .command('pub')
            .description('Publish a custom number of messages at a custom rate.')
            .option('-c, --count <NUMBER>', 'the number of connections', parse_1.parseNumber, 1000)
            .option('-i, --interval <MILLISECONDS>', 'interval of connecting to the broker', parse_1.parseNumber, 10)
            .option('-im, --message-interval <MILLISECONDS>', 'interval of publishing messages', parse_1.parseNumber, 1000)
            .option('-L, --limit <NUMBER>', 'the maximum number of messages to publish. a value of 0 means no limit on the number of messages', parse_1.parseNumber, 0)
            .option('-t, --topic <TOPIC>', 'the message topic, support %u (username), %c (client id), %i (index) variables', parse_1.parsePubTopic)
            .option('-m, --message <BODY>', 'the message body', 'Hello From MQTTX CLI')
            .option('-q, --qos <0/1/2>', 'the QoS of the message', parse_1.parseNumber, 0)
            .option('-r, --retain', 'send a retained message')
            .option('-d, --dup', 'mark as duplicate flag')
            // properties options of MQTT 5.0
            .option('-pf, --payload-format-indicator', 'the payload format indicator of the publish message')
            .option('-e, --message-expiry-interval <NUMBER>', 'the lifetime of the publish message in seconds', parse_1.parseNumber)
            .option('-ta, --topic-alias <NUMBER>', 'value that is used to identify the topic instead of using the topic name', parse_1.parseNumber)
            .option('-rt, --response-topic <TOPIC>', 'string which is used as the topic name for a response message')
            .option('-cd, --correlation-data <DATA>', 'used by the sender of the request message to identify which request the response message is for when it is received')
            .option('-up, --user-properties <USERPROPERTIES...>', 'the user properties of MQTT 5.0 (e.g. -up "name: mqttx cli")', parse_1.parseKeyValues)
            .option('-si, --subscription-identifier <NUMBER>', 'the identifier of the subscription', parse_1.parseNumber)
            .option('-ct, --content-type <TYPE>', 'a description of the content of the publish message')
            .option('-v, --verbose', 'print history published total and message rate')
            // connect options
            .option('-V, --mqtt-version <5.0/3.1.1/3.1>', 'the MQTT version', parse_1.parseMQTTVersion, 5)
            .option('-h, --hostname <HOST>', 'the broker host', state_1.default.getConfig('host'))
            .option('-p, --port <PORT>', 'the broker port', parse_1.parseNumber, state_1.default.getConfig('port'))
            .option('-I, --client-id <ID>', 'the client id, support %i (index) variable', (0, generator_1.getClientId)())
            .option('--no-clean', 'set the clean session flag to false', true)
            .option('-k, --keepalive <SEC>', 'send a ping every SEC seconds', parse_1.parseNumber, 30)
            .option('-u, --username <USER>', 'the username', state_1.default.getConfig('username'))
            .option('-P, --password <PASS>', 'the password', state_1.default.getConfig('password'))
            .option('-l, --protocol <PROTO>', 'the protocol to use, mqtt, mqtts, ws, or wss', parse_1.parseProtocol, state_1.default.getConfig('protocol'))
            .option('--path <PATH>', 'the path of websocket', '/mqtt')
            .option('-wh, --ws-headers <WSHEADERS...>', 'headers for WebSocket options (only works with MQTT over WebSocket connections, e.g. -wh "Authorization: Bearer token")', parse_1.parseKeyValues)
            .option('--key <PATH>', 'path to the key file')
            .option('--cert <PATH>', 'path to the cert file')
            .option('--ca <PATH>', 'path to the ca certificate')
            .option('--insecure', 'do not verify the server certificate')
            .option('--alpn <PROTO...>', 'set one or multiple ALPN (Application Layer Protocol Negotiation) protocols')
            .option('-rp, --reconnect-period <MILLISECONDS>', 'interval between two reconnections, disable auto reconnect by setting to 0', parse_1.parseNumber, 1000)
            .option('--maximum-reconnect-times <NUMBER>', 'the maximum reconnect times', parse_1.parseNumber, state_1.default.getConfig('maxReconnectTimes'))
            // connect properties options of MQTT 5.0
            .option('-se, --session-expiry-interval <SECONDS>', 'the session expiry interval in seconds', parse_1.parseNumber)
            .option('--rcv-max, --receive-maximum <NUMBER>', 'the receive maximum value', parse_1.parseNumber)
            .option('--maximum-packet-size <NUMBER>', 'the maximum packet size the client is willing to accept', parse_1.parseNumber)
            .option('--topic-alias-maximum <NUMBER>', 'the topic alias maximum value', parse_1.parseNumber)
            .option('--req-response-info', 'the client requests response information from the server')
            .option('--no-req-problem-info', 'the client requests problem information from the server')
            .option('-Cup, --conn-user-properties <USERPROPERTIES...>', 'the connect user properties of MQTT 5.0 (e.g. -up "name: mqttx cli")', parse_1.parseKeyValues)
            // will message options
            .option('-Wt, --will-topic <TOPIC>', 'the will topic')
            .option('-Wm, --will-message <BODY>', 'the will message')
            .option('-Wq, --will-qos <0/1/2>', 'the will qos', parse_1.parseNumber)
            .option('-Wr, --will-retain', 'send a will retained message')
            // will message properties options of MQTT 5.0
            .option('-Wd, --will-delay-interval <SECONDS>', 'the will delay interval in seconds', parse_1.parseNumber)
            .option('-Wpf, --will-payload-format-indicator', 'will message is UTF-8 encoded character data or not')
            .option('-We, --will-message-expiry-interval <SECONDS>', 'lifetime of the will message in seconds', parse_1.parseNumber)
            .option('-Wct, --will-content-type <CONTENTTYPE>', 'description of the will message’s content')
            .option('-Wrt, --will-response-topic <TOPIC>', 'topic name for a response message')
            .option('-Wcd, --will-correlation-data <DATA>', 'correlation data for the response message')
            .option('-Wup, --will-user-properties <USERPROPERTIES...>', 'the user properties of will message', parse_1.parseKeyValues)
            .option('-so, --save-options [PATH]', 'save the parameters to the local configuration file, which supports json and yaml format, default path is ./mqttx-cli-options.json')
            .option('-lo, --load-options [PATH]', 'load the parameters from the local configuration file, which supports json and yaml format, default path is ./mqttx-cli-options.json')
            .option('--file-read <PATH>', 'read the message body from the file', parse_1.parseFileRead)
            .option('--split [CHARACTER]', 'split the input message in a single file by a specified character, default is "\\n"')
            .allowUnknownOption(false)
            .hook('preAction', function (thisCommand) {
            globalThis.command = thisCommand;
        })
            .action(pub_1.benchPub);
        benchCmd
            .command('sub')
            .description('Create a custom number of connections then subscribe to one or multiple topics.')
            .option('-c, --count <NUMBER>', 'the number of connections', parse_1.parseNumber, 1000)
            .option('-i, --interval <MILLISECONDS>', 'interval of connecting to the broker', parse_1.parseNumber, 10)
            .option('-t, --topic <TOPIC...>', 'the message topic, support %u (username), %c (client id), %i (index) variables')
            .option('-q, --qos <0/1/2...>', 'the QoS of the message', parse_1.parseQoS)
            // properties options of MQTT 5.0
            .option('-nl, --no_local [FLAG...]', 'the no local MQTT 5.0 flag', parse_1.parseVariadicOfBooleanType)
            .option('-rap, --retain-as-published [FLAG...]', 'the retain as published MQTT 5.0 flag', parse_1.parseVariadicOfBooleanType)
            .option('-rh, --retain-handling <0/1/2...>', 'the retain handling MQTT 5.0', parse_1.parseQoS)
            .option('-si, --subscription-identifier <NUMBER...>', 'the identifier of the subscription', parse_1.parseNumber)
            .option('-up, --user-properties <USERPROPERTIES...>', 'the user properties of MQTT 5.0 (e.g. -up "name: mqttx cli")', parse_1.parseKeyValues)
            .option('-v, --verbose', 'print history received messages and rate')
            // connect options
            .option('-V, --mqtt-version <5.0/3.1.1/3.1>', 'the MQTT version', parse_1.parseMQTTVersion, 5)
            .option('-h, --hostname <HOST>', 'the broker host', state_1.default.getConfig('host'))
            .option('-p, --port <PORT>', 'the broker port', parse_1.parseNumber, state_1.default.getConfig('port'))
            .option('-I, --client-id <ID>', 'the client id, support %i (index) variable', (0, generator_1.getClientId)())
            .option('--no-clean', 'set the clean session flag to false', true)
            .option('-u, --username <USER>', 'the username', state_1.default.getConfig('username'))
            .option('-P, --password <PASS>', 'the password', state_1.default.getConfig('password'))
            .option('-l, --protocol <PROTO>', 'the protocol to use, mqtt, mqtts, ws, or wss', parse_1.parseProtocol, state_1.default.getConfig('protocol'))
            .option('--path <PATH>', 'the path of websocket', '/mqtt')
            .option('-wh, --ws-headers <WSHEADERS...>', 'headers for WebSocket options (only works with MQTT over WebSocket connections, e.g. -wh "Authorization: Bearer token")', parse_1.parseKeyValues)
            .option('--key <PATH>', 'path to the key file')
            .option('--cert <PATH>', 'path to the cert file')
            .option('--ca <PATH>', 'path to the ca certificate')
            .option('--insecure', 'do not verify the server certificate')
            .option('--alpn <PROTO...>', 'set one or multiple ALPN (Application Layer Protocol Negotiation) protocols')
            .option('-rp, --reconnect-period <MILLISECONDS>', 'interval between two reconnections, disable auto reconnect by setting to 0', parse_1.parseNumber, 1000)
            .option('--maximum-reconnect-times <NUMBER>', 'the maximum reconnect times', parse_1.parseNumber, state_1.default.getConfig('maxReconnectTimes'))
            // connect properties options of MQTT 5.0
            .option('-se, --session-expiry-interval <SECONDS>', 'the session expiry interval in seconds', parse_1.parseNumber)
            .option('--rcv-max, --receive-maximum <NUMBER>', 'the receive maximum value', parse_1.parseNumber)
            .option('--maximum-packet-size <NUMBER>', 'the maximum packet size the client is willing to accept', parse_1.parseNumber)
            .option('--topic-alias-maximum <NUMBER>', 'the topic alias maximum value', parse_1.parseNumber)
            .option('--req-response-info', 'the client requests response information from the server')
            .option('--no-req-problem-info', 'the client requests problem information from the server')
            .option('-Cup, --conn-user-properties <USERPROPERTIES...>', 'the connect user properties of MQTT 5.0 (e.g. -up "name: mqttx cli")', parse_1.parseKeyValues)
            // will message options
            .option('-Wt, --will-topic <TOPIC>', 'the will topic')
            .option('-Wm, --will-message <BODY>', 'the will message')
            .option('-Wq, --will-qos <0/1/2>', 'the will qos', parse_1.parseNumber)
            .option('-Wr, --will-retain', 'send a will retained message')
            // will message properties options of MQTT 5.0
            .option('-Wd, --will-delay-interval <SECONDS>', 'the will delay interval in seconds', parse_1.parseNumber)
            .option('-Wpf, --will-payload-format-indicator', 'will message is UTF-8 encoded character data or not')
            .option('-We, --will-message-expiry-interval <SECONDS>', 'lifetime of the will message in seconds', parse_1.parseNumber)
            .option('-Wct, --will-content-type <CONTENTTYPE>', 'description of the will message’s content')
            .option('-Wrt, --will-response-topic <TOPIC>', 'topic name for a response message')
            .option('-Wcd, --will-correlation-data <DATA>', 'correlation data for the response message')
            .option('-Wup, --will-user-properties <USERPROPERTIES...>', 'the user properties of will message', parse_1.parseKeyValues)
            .option('-so, --save-options [PATH]', 'save the parameters to the local configuration file, which supports json and yaml format, default path is ./mqttx-cli-options.json')
            .option('-lo, --load-options [PATH]', 'load the parameters from the local configuration file, which supports json and yaml format, default path is ./mqttx-cli-options.json')
            .allowUnknownOption(false)
            .hook('preAction', function (thisCommand) {
            globalThis.command = thisCommand;
        })
            .action(sub_1.benchSub);
        this.program
            .command('simulate')
            .description('Publish scenario-specific simulation messages at a custom rate and a number of connections.')
            .option('-sc, --scenario <SCENARIO>', 'the name of the built-in scenario to execute')
            .option('-f, --file <SCENARIO FILE PATH>', 'the path of the custom script file to simulate')
            .option('-c, --count <NUMBER>', 'the number of connections', parse_1.parseNumber, 1000)
            .option('-i, --interval <MILLISECONDS>', 'interval of connecting to the broker', parse_1.parseNumber, 10)
            .option('-im, --message-interval <MILLISECONDS>', 'interval of publishing messages', parse_1.parseNumber, 1000)
            .option('-L, --limit <NUMBER>', 'the maximum number of messages to publish. a value of 0 means no limit on the number of messages', parse_1.parseNumber, 0)
            .option('-t, --topic <TOPIC>', 'the message topic, support %u (username), %c (client id), %i (index), %sc (scenario) variables', parse_1.parsePubTopic, 'mqttx/simulate/%sc/%c')
            .option('-q, --qos <0/1/2>', 'the QoS of the message', parse_1.parseNumber, 0)
            .option('-r, --retain', 'send a retained message')
            .option('-d, --dup', 'mark as duplicate flag')
            // properties options of MQTT 5.0
            .option('-pf, --payload-format-indicator', 'the payload format indicator of the publish message')
            .option('-e, --message-expiry-interval <NUMBER>', 'the lifetime of the publish message in seconds', parse_1.parseNumber)
            .option('-ta, --topic-alias <NUMBER>', 'value that is used to identify the topic instead of using the topic name', parse_1.parseNumber)
            .option('-rt, --response-topic <TOPIC>', 'string which is used as the topic name for a response message')
            .option('-cd, --correlation-data <DATA>', 'used by the sender of the request message to identify which request the response message is for when it is received')
            .option('-up, --user-properties <USERPROPERTIES...>', 'the user properties of MQTT 5.0 (e.g. -up "name: mqttx cli")', parse_1.parseKeyValues)
            .option('-si, --subscription-identifier <NUMBER>', 'the identifier of the subscription', parse_1.parseNumber)
            .option('-ct, --content-type <TYPE>', 'a description of the content of the publish message')
            .option('-v, --verbose', 'print history published total and message rate')
            // connect options
            .option('-V, --mqtt-version <5.0/3.1.1/3.1>', 'the MQTT version', parse_1.parseMQTTVersion, 5)
            .option('-h, --hostname <HOST>', 'the broker host', state_1.default.getConfig('host'))
            .option('-p, --port <PORT>', 'the broker port', parse_1.parseNumber, state_1.default.getConfig('port'))
            .option('-I, --client-id <ID>', 'the client id, support %i (index) variable', (0, generator_1.getClientId)())
            .option('--no-clean', 'set the clean session flag to false', true)
            .option('-k, --keepalive <SEC>', 'send a ping every SEC seconds', parse_1.parseNumber, 30)
            .option('-u, --username <USER>', 'the username', state_1.default.getConfig('username'))
            .option('-P, --password <PASS>', 'the password', state_1.default.getConfig('password'))
            .option('-l, --protocol <PROTO>', 'the protocol to use, mqtt, mqtts, ws, or wss', parse_1.parseProtocol, state_1.default.getConfig('protocol'))
            .option('--path <PATH>', 'the path of websocket', '/mqtt')
            .option('-wh, --ws-headers <WSHEADERS...>', 'headers for WebSocket options (only works with MQTT over WebSocket connections, e.g. -wh "Authorization: Bearer token")', parse_1.parseKeyValues)
            .option('--key <PATH>', 'path to the key file')
            .option('--cert <PATH>', 'path to the cert file')
            .option('--ca <PATH>', 'path to the ca certificate')
            .option('--insecure', 'do not verify the server certificate')
            .option('--alpn <PROTO...>', 'set one or multiple ALPN (Application Layer Protocol Negotiation) protocols')
            .option('-rp, --reconnect-period <MILLISECONDS>', 'interval between two reconnections, disable auto reconnect by setting to 0', parse_1.parseNumber, 1000)
            .option('--maximun-reconnect-times <NUMBER>', 'the maximum reconnect times', parse_1.parseNumber, 10)
            // connect properties options of MQTT 5.0
            .option('-se, --session-expiry-interval <SECONDS>', 'the session expiry interval in seconds', parse_1.parseNumber)
            .option('--rcv-max, --receive-maximum <NUMBER>', 'the receive maximum value', parse_1.parseNumber)
            .option('--maximum-packet-size <NUMBER>', 'the maximum packet size the client is willing to accept', parse_1.parseNumber)
            .option('--topic-alias-maximum <NUMBER>', 'the topic alias maximum value', parse_1.parseNumber)
            .option('--req-response-info', 'the client requests response information from the server')
            .option('--no-req-problem-info', 'the client requests problem information from the server')
            .option('-Cup, --conn-user-properties <USERPROPERTIES...>', 'the connect user properties of MQTT 5.0 (e.g. -up "name: mqttx cli")', parse_1.parseKeyValues)
            // will message options
            .option('-Wt, --will-topic <TOPIC>', 'the will topic')
            .option('-Wm, --will-message <BODY>', 'the will message')
            .option('-Wq, --will-qos <0/1/2>', 'the will qos', parse_1.parseNumber)
            .option('-Wr, --will-retain', 'send a will retained message')
            // will message properties options of MQTT 5.0
            .option('-Wd, --will-delay-interval <SECONDS>', 'the will delay interval in seconds', parse_1.parseNumber)
            .option('-Wpf, --will-payload-format-indicator', 'will message is UTF-8 encoded character data or not')
            .option('-We, --will-message-expiry-interval <SECONDS>', 'lifetime of the will message in seconds', parse_1.parseNumber)
            .option('-Wct, --will-content-type <CONTENTTYPE>', 'description of the will message’s content')
            .option('-Wrt, --will-response-topic <TOPIC>', 'topic name for a response message')
            .option('-Wcd, --will-correlation-data <DATA>', 'correlation data for the response message')
            .option('-Wup, --will-user-properties <USERPROPERTIES...>', 'the user properties of will message', parse_1.parseKeyValues)
            .option('-so, --save-options [PATH]', 'save the parameters to the local configuration file, which supports json and yaml format, default path is ./mqttx-cli-options.json')
            .option('-lo, --load-options [PATH]', 'load the parameters from the local configuration file, which supports json and yaml format, default path is ./mqttx-cli-options.json')
            .allowUnknownOption(false)
            .hook('preAction', function (thisCommand) {
            globalThis.command = thisCommand;
        })
            .action(pub_1.simulatePub);
        this.program
            .command('ls')
            .description('List information based on the provided options.')
            .option('-sc, --scenarios', 'List all built-in scenarios')
            .allowUnknownOption(false)
            .hook('preAction', function (thisCommand) {
            globalThis.command = thisCommand;
        })
            .action(ls_1.default);
    };
    return Commander;
}());
exports.Commander = Commander;
exports.default = Commander;
