"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.benchConn = exports.conn = void 0;
var mqtt = __importStar(require("mqtt"));
var logWrapper_1 = require("../utils/logWrapper");
var parse_1 = require("../utils/parse");
var delay_1 = __importDefault(require("../utils/delay"));
var options_1 = require("../utils/options");
var Debug = __importStar(require("debug"));
var exitInfo_1 = require("../utils/exitInfo");
var getBenchClientId_1 = __importDefault(require("../utils/getBenchClientId"));
var conn = function (options) {
    var debug = options.debug, saveOptions = options.saveOptions, loadOptions = options.loadOptions;
    loadOptions && (options = (0, options_1.handleLoadOptions)('conn', loadOptions, options));
    saveOptions && (0, options_1.handleSaveOptions)('conn', options);
    debug && Debug.enable('mqttjs*');
    var maximumReconnectTimes = options.maximumReconnectTimes;
    var connOpts = (0, parse_1.parseConnectOptions)(options, 'conn');
    var client = mqtt.connect(connOpts);
    var retryTimes = 0;
    logWrapper_1.basicLog.connecting(loadOptions, connOpts.hostname, connOpts.port);
    client.on('connect', function () {
        logWrapper_1.basicLog.connected();
        retryTimes = 0;
        setTimeout(exitInfo_1.triggerExitInfo, 1000);
    });
    client.on('error', function (err) {
        logWrapper_1.basicLog.error(err);
        client.end();
    });
    client.on('reconnect', function () {
        retryTimes += 1;
        if (retryTimes > maximumReconnectTimes) {
            client.end(false, {}, function () {
                logWrapper_1.basicLog.reconnectTimesLimit();
            });
        }
        else {
            logWrapper_1.basicLog.reconnecting(retryTimes, maximumReconnectTimes);
        }
    });
    client.on('close', function () {
        logWrapper_1.basicLog.close();
    });
    client.on('disconnect', function (packet) {
        logWrapper_1.basicLog.disconnect(packet);
    });
};
exports.conn = conn;
var benchConn = function (options) { return __awaiter(void 0, void 0, void 0, function () {
    var saveOptions, loadOptions, count, interval, hostname, port, clientId, maximumReconnectTimes, connOpts, connectedCount, isNewConnArray, retryTimesArray, interactiveConn, start, i;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                saveOptions = options.saveOptions, loadOptions = options.loadOptions;
                loadOptions && (options = (0, options_1.handleLoadOptions)('benchConn', loadOptions, options));
                saveOptions && (0, options_1.handleSaveOptions)('benchConn', options);
                count = options.count, interval = options.interval, hostname = options.hostname, port = options.port, clientId = options.clientId, maximumReconnectTimes = options.maximumReconnectTimes;
                connOpts = (0, parse_1.parseConnectOptions)(options, 'conn');
                connectedCount = 0;
                isNewConnArray = Array(count).fill(true);
                retryTimesArray = Array(count).fill(0);
                interactiveConn = new logWrapper_1.Signale({ interactive: true, config: logWrapper_1.singaleConfig });
                logWrapper_1.benchLog.start.conn(loadOptions, count, interval, hostname, port);
                start = Date.now();
                i = 1;
                _a.label = 1;
            case 1:
                if (!(i <= count)) return [3 /*break*/, 4];
                ;
                (function (i, connOpts) {
                    var opts = __assign({}, connOpts);
                    opts.clientId = (0, getBenchClientId_1.default)(clientId, i, count);
                    var client = mqtt.connect(opts);
                    interactiveConn.await('[%d/%d] - Connecting...', connectedCount, count);
                    client.on('connect', function () {
                        connectedCount += 1;
                        retryTimesArray[i - 1] = 0;
                        if (isNewConnArray[i - 1]) {
                            interactiveConn.success('[%d/%d] - Connected', connectedCount, count);
                            if (connectedCount === count) {
                                var end = Date.now();
                                logWrapper_1.signale.success("Created ".concat(count, " connections in ").concat((end - start) / 1000, "s"));
                                setTimeout(exitInfo_1.triggerExitInfo, 1000);
                            }
                        }
                        else {
                            logWrapper_1.benchLog.reconnected(connectedCount, count, opts.clientId);
                        }
                    });
                    client.on('error', function (err) {
                        logWrapper_1.benchLog.error(connectedCount, count, opts.clientId, err);
                        client.end();
                    });
                    client.on('reconnect', function () {
                        retryTimesArray[i - 1] += 1;
                        if (retryTimesArray[i - 1] > maximumReconnectTimes) {
                            client.end(false, {}, function () {
                                logWrapper_1.benchLog.reconnectTimesLimit(connectedCount, count, opts.clientId);
                            });
                        }
                        else {
                            logWrapper_1.benchLog.reconnecting(connectedCount, count, opts.clientId);
                            isNewConnArray[i - 1] = false;
                        }
                    });
                    client.on('close', function () {
                        connectedCount > 0 && (connectedCount -= 1);
                        logWrapper_1.benchLog.close(connectedCount, count, opts.clientId);
                    });
                    client.on('disconnect', function (packet) {
                        logWrapper_1.basicLog.disconnect(packet, opts.clientId);
                    });
                })(i, connOpts);
                return [4 /*yield*/, (0, delay_1.default)(interval)];
            case 2:
                _a.sent();
                _a.label = 3;
            case 3:
                i++;
                return [3 /*break*/, 1];
            case 4: return [2 /*return*/];
        }
    });
}); };
exports.benchConn = benchConn;
exports.default = conn;
