"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.simulatePub = exports.benchPub = exports.pub = void 0;
var concat_stream_1 = __importDefault(require("concat-stream"));
var Debug = __importStar(require("debug"));
var lodash_1 = __importDefault(require("lodash"));
var mqtt = __importStar(require("mqtt"));
var pump_1 = __importDefault(require("pump"));
var readable_stream_1 = require("readable-stream");
var split2_1 = __importDefault(require("split2"));
var convertPayload_1 = __importDefault(require("../utils/convertPayload"));
var delay_1 = __importDefault(require("../utils/delay"));
var fileUtils_1 = require("../utils/fileUtils");
var logWrapper_1 = __importStar(require("../utils/logWrapper"));
var options_1 = require("../utils/options");
var parse_1 = require("../utils/parse");
var protobuf_1 = require("../utils/protobuf");
var avro_1 = require("../utils/avro");
var simulate_1 = require("../utils/simulate");
var exitInfo_1 = require("../utils/exitInfo");
var getBenchClientId_1 = __importDefault(require("../utils/getBenchClientId"));
/**
 * Processes the outgoing message through two potential stages:
 * 1. Format Conversion: If a format is specified, transform the message into that format.
 *    If no format is specified, the message retains its initial state.
 * 2. Protobuf Serialization: If both protobuf path and message name are present,
 *    encapsulate the message into a protobuf format. If these settings are absent,
 *    the message remains unchanged.
 * Flow:
 *   Input Message -> [Format Conversion] -> Schema [Protobuf, Avro] -> Output Message
 * @param {string | Buffer} message - The message to be processed.
 * @param {SchemaOptions} [schemaOptions] - Options for schema-based encoding
 * @param {FormatType} [format] - The format to convert the message to.
 * @returns {Buffer | string} - The processed message.
 */
var processPublishMessage = function (message, schemaOptions, format) {
    var convertMessageFormat = function (msg) {
        if (!format) {
            return msg;
        }
        var bufferMsg = Buffer.isBuffer(msg) ? msg : Buffer.from(msg.toString());
        return (0, convertPayload_1.default)(bufferMsg, format, 'encode');
    };
    var serializeWithSchema = function (msg) {
        if (!schemaOptions)
            return msg;
        switch (schemaOptions.type) {
            case 'protobuf':
                return (0, protobuf_1.serializeProtobufToBuffer)(msg, schemaOptions.protobufPath, schemaOptions.protobufMessageName);
            case 'avro':
                return (0, avro_1.serializeAvroToBuffer)(msg, schemaOptions.avscPath);
        }
    };
    var pipeline = [convertMessageFormat, serializeWithSchema];
    return pipeline.reduce(function (msg, transformer) { return transformer(msg); }, message);
};
var send = function (config, connOpts, pubOpts, maximumReconnectTimes) {
    var retryTimes = 0;
    var isNewConnection = true;
    var client = mqtt.connect(connOpts);
    logWrapper_1.basicLog.connecting(config, connOpts.hostname, connOpts.port, pubOpts.topic, pubOpts.message.toString());
    client.on('connect', function () {
        retryTimes = 0;
        logWrapper_1.basicLog.connected();
        var topic = pubOpts.topic, message = pubOpts.message, schemaOptions = pubOpts.schemaOptions, format = pubOpts.format;
        logWrapper_1.basicLog.publishing();
        var publishMessage = processPublishMessage(message, schemaOptions, format);
        client.publish(topic, publishMessage, pubOpts.opts, function (err) {
            var _a;
            if (err) {
                logWrapper_1.basicLog.error(err);
                process.exit(1);
            }
            else {
                logWrapper_1.basicLog.published();
            }
            // FIXME: When using the ws and wss protocols to connect, and QoS is 0, the message may not have been successfully sent when the publish callback is triggered. Therefore, delay closing the connection for 2 seconds.
            if (['ws', 'wss'].includes((_a = connOpts.protocol) !== null && _a !== void 0 ? _a : '') && pubOpts.opts.qos === 0) {
                setTimeout(function () {
                    client.end();
                }, 2000);
            }
            else {
                client.end();
            }
        });
    });
    client.on('error', function (err) {
        logWrapper_1.basicLog.error(err);
        client.end();
    });
    client.on('reconnect', function () {
        retryTimes += 1;
        if (retryTimes > maximumReconnectTimes) {
            client.end(true, {}, function () {
                logWrapper_1.basicLog.reconnectTimesLimit();
                process.exit(1);
            });
        }
        else {
            logWrapper_1.basicLog.reconnecting(retryTimes, maximumReconnectTimes);
            isNewConnection = false;
        }
    });
    client.on('disconnect', function (packet) {
        logWrapper_1.basicLog.disconnect(packet);
    });
};
var multiSend = function (config, connOpts, pubOpts, maximumReconnectTimes) {
    var isNewConnection = true;
    var retryTimes = 0;
    var client = mqtt.connect(connOpts);
    logWrapper_1.basicLog.connecting(config, connOpts.hostname, connOpts.port, pubOpts.topic);
    var sender = new readable_stream_1.Writable({
        objectMode: true,
    });
    var count = 0;
    sender._write = function (line, _enc, cb) {
        var _a;
        var topic = pubOpts.topic, opts = pubOpts.opts, schemaOptions = pubOpts.schemaOptions, format = pubOpts.format;
        count++;
        var omitTopic = ((_a = opts.properties) === null || _a === void 0 ? void 0 : _a.topicAlias) && count >= 2;
        var publishMessage = processPublishMessage(line.trim(), schemaOptions, format);
        client.publish(omitTopic ? '' : topic, publishMessage, opts, cb);
    };
    client.on('connect', function () {
        logWrapper_1.basicLog.enterToPublish();
        setTimeout(exitInfo_1.triggerExitInfo, 1000);
        retryTimes = 0;
        isNewConnection &&
            (0, pump_1.default)(process.stdin, (0, split2_1.default)(), sender, function (err) {
                client.end();
                if (err) {
                    logWrapper_1.basicLog.error(err);
                    process.exit(1);
                }
            });
    });
    client.on('error', function (err) {
        logWrapper_1.basicLog.error(err);
        client.end();
    });
    client.on('reconnect', function () {
        retryTimes += 1;
        if (retryTimes > maximumReconnectTimes) {
            client.end(true, {}, function () {
                logWrapper_1.basicLog.reconnectTimesLimit();
                process.exit(1);
            });
        }
        else {
            logWrapper_1.basicLog.reconnecting(retryTimes, maximumReconnectTimes);
            isNewConnection = false;
            sender.uncork();
        }
    });
    client.on('close', function () {
        logWrapper_1.basicLog.close();
        var reconnectPeriod = connOpts.reconnectPeriod;
        reconnectPeriod ? sender.cork() : process.exit(1);
    });
    client.on('disconnect', function (packet) {
        logWrapper_1.basicLog.disconnect(packet);
    });
};
var handlePipedMultiline = function (connOpts, pubOpts) {
    var client = mqtt.connect(connOpts);
    var messageQueue = [];
    var publishedCount = 0;
    process.stdin.pipe((0, split2_1.default)()).on('data', function (chunk) {
        var message = chunk.toString();
        if (message.length > 0) {
            messageQueue.push(message);
        }
    });
    client.on('connect', function () {
        logWrapper_1.basicLog.connected();
        if (messageQueue.length > 0) {
            logWrapper_1.default.await("Publishing ".concat(messageQueue.length, " messages..."));
            messageQueue.forEach(function (message) {
                client.publish(pubOpts.topic, Buffer.from(message), pubOpts.opts, function (err) {
                    if (err) {
                        logWrapper_1.basicLog.error(err);
                    }
                    else {
                        publishedCount++;
                        if (publishedCount === messageQueue.length) {
                            logWrapper_1.default.success("Successfully published ".concat(publishedCount, " messages"));
                        }
                    }
                });
            });
            setTimeout(function () {
                client.end();
            }, 1000);
        }
    });
    client.on('error', function (err) {
        logWrapper_1.basicLog.error(err);
        client.end();
    });
};
var handleFileRead = function (filePath) {
    try {
        logWrapper_1.basicLog.fileReading();
        var bufferData = (0, fileUtils_1.readFile)(filePath);
        logWrapper_1.basicLog.fileReadSuccess();
        return bufferData;
    }
    catch (err) {
        var error = err;
        logWrapper_1.default.fail("Failed to read file: ".concat(error.toString()));
        process.exit(1);
    }
};
var pub = function (options) {
    var debug = options.debug, saveOptions = options.saveOptions, loadOptions = options.loadOptions;
    loadOptions && (options = (0, options_1.handleLoadOptions)('pub', loadOptions, options));
    saveOptions && (0, options_1.handleSaveOptions)('pub', options);
    debug && Debug.enable('mqttjs*');
    (0, parse_1.checkTopicExists)(options.topic, 'pub');
    if (options.lineMode) {
        options.multiline = true;
        options.stdin = true;
    }
    var connOpts = (0, parse_1.parseConnectOptions)(options, 'pub');
    var pubOpts = (0, parse_1.parsePublishOptions)(options);
    var handleStdin = function () {
        // One line mode
        if (!options.multiline) {
            return process.stdin.pipe((0, concat_stream_1.default)(function (data) {
                pubOpts.message = data;
                send(loadOptions, connOpts, pubOpts, options.maximumReconnectTimes);
            }));
        }
        // Multiline mode
        var isPiped = !process.stdin.isTTY;
        return isPiped
            ? handlePipedMultiline(connOpts, pubOpts)
            : multiSend(loadOptions, connOpts, pubOpts, options.maximumReconnectTimes);
    };
    if (options.fileRead) {
        var bufferData = handleFileRead((0, fileUtils_1.processPath)(options.fileRead));
        pubOpts.message = bufferData;
        send(loadOptions, connOpts, pubOpts, options.maximumReconnectTimes);
    }
    else if (options.stdin) {
        handleStdin();
    }
    else {
        send(loadOptions, connOpts, pubOpts, options.maximumReconnectTimes);
    }
};
exports.pub = pub;
var multiPub = function (commandType, options) { return __awaiter(void 0, void 0, void 0, function () {
    var saveOptions, loadOptions, simulator, simulateOptions, count, interval, messageInterval, limit, hostname, port, topic, clientId, message, fileRead, verbose, maximumReconnectTimes, split, fileData, splitedMessageArr, connOpts, pubOpts, username, initialized, connectedCount, inFlightMessageCount, splitLimit, isNewConnArray, retryTimesArray, interactivePub, connStart, total, rate, _loop_1, i;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                saveOptions = options.saveOptions, loadOptions = options.loadOptions;
                simulator = {};
                if (commandType === 'simulate') {
                    options = loadOptions ? (0, options_1.handleLoadOptions)('simulate', loadOptions, options) : options;
                    saveOptions && (0, options_1.handleSaveOptions)('simulate', options);
                    simulateOptions = options;
                    (0, parse_1.checkScenarioExists)(simulateOptions.scenario, simulateOptions.file);
                    simulator = (0, simulate_1.loadSimulator)(simulateOptions.scenario, simulateOptions.file);
                }
                else {
                    options = loadOptions ? (0, options_1.handleLoadOptions)('benchPub', loadOptions, options) : options;
                    saveOptions && (0, options_1.handleSaveOptions)('benchPub', options);
                }
                count = options.count, interval = options.interval, messageInterval = options.messageInterval, limit = options.limit, hostname = options.hostname, port = options.port, topic = options.topic, clientId = options.clientId, message = options.message, fileRead = options.fileRead, verbose = options.verbose, maximumReconnectTimes = options.maximumReconnectTimes, split = options.split;
                splitedMessageArr = [];
                if (fileRead) {
                    fileData = handleFileRead((0, fileUtils_1.processPath)(fileRead));
                    if (split) {
                        splitedMessageArr = (0, fileUtils_1.fileDataSplitter)(fileData, split);
                    }
                }
                (0, parse_1.checkTopicExists)(topic, commandType);
                connOpts = (0, parse_1.parseConnectOptions)(options, 'pub');
                pubOpts = (0, parse_1.parsePublishOptions)(options);
                username = connOpts.username;
                initialized = false;
                connectedCount = 0;
                inFlightMessageCount = 0;
                splitLimit = splitedMessageArr.length * count;
                isNewConnArray = Array(count).fill(true);
                retryTimesArray = Array(count).fill(0);
                interactivePub = new logWrapper_1.Signale({ interactive: true, config: logWrapper_1.singaleConfig });
                if (commandType === 'simulate') {
                    logWrapper_1.simulateLog.start.pub(loadOptions, count, interval, messageInterval, hostname, port, topic, simulator.name || simulator.file);
                }
                else if (commandType === 'benchPub') {
                    logWrapper_1.benchLog.start.pub(loadOptions, count, interval, messageInterval, hostname, port, topic, message.toString());
                }
                connStart = Date.now();
                total = 0;
                rate = 0;
                _loop_1 = function (i) {
                    var dupSplitedMessageArr;
                    return __generator(this, function (_b) {
                        switch (_b.label) {
                            case 0:
                                dupSplitedMessageArr = splitedMessageArr.length !== 0 ? lodash_1.default.cloneDeep(splitedMessageArr) : [];
                                (function (i, connOpts) {
                                    var opts = __assign({}, connOpts);
                                    opts.clientId = (0, getBenchClientId_1.default)(clientId, i, count);
                                    var topicName = topic.replaceAll('%i', i.toString()).replaceAll('%c', clientId);
                                    username && (topicName = topicName.replaceAll('%u', username));
                                    simulator && (topicName = topicName.replaceAll('%sc', simulator.name));
                                    var client = mqtt.connect(opts);
                                    interactivePub.await('[%d/%d] - Connecting...', connectedCount, count);
                                    client.on('connect', function () {
                                        connectedCount += 1;
                                        retryTimesArray[i - 1] = 0;
                                        if (isNewConnArray[i - 1]) {
                                            interactivePub.success('[%d/%d] - Connected', connectedCount, count);
                                            setInterval(function () { return __awaiter(void 0, void 0, void 0, function () {
                                                var publishTopic, publishMessage, simulationResult;
                                                return __generator(this, function (_a) {
                                                    switch (_a.label) {
                                                        case 0:
                                                            if (!(limit > 0 && total >= limit)) return [3 /*break*/, 2];
                                                            // Wait for the total number of sent messages to be printed, then exit the process.
                                                            return [4 /*yield*/, (0, delay_1.default)(1000)];
                                                        case 1:
                                                            // Wait for the total number of sent messages to be printed, then exit the process.
                                                            _a.sent();
                                                            logWrapper_1.default.success("All ".concat(total, " messages have been sent, reaching the limit of ").concat(limit, "."));
                                                            process.exit(0);
                                                            _a.label = 2;
                                                        case 2:
                                                            if (!(splitLimit > 0 && total >= splitLimit)) return [3 /*break*/, 4];
                                                            // Wait for the total number of sent messages to be printed, then exit the process.
                                                            return [4 /*yield*/, (0, delay_1.default)(1000)];
                                                        case 3:
                                                            // Wait for the total number of sent messages to be printed, then exit the process.
                                                            _a.sent();
                                                            logWrapper_1.default.success("All ".concat(total, " messages from the ").concat(fileRead, " have been successfully sent."));
                                                            process.exit(0);
                                                            _a.label = 4;
                                                        case 4:
                                                            // If not initialized or client is not connected or message count exceeds the limit, do not send messages.
                                                            if (!initialized ||
                                                                !client.connected ||
                                                                (limit > 0 && total + inFlightMessageCount >= limit) ||
                                                                (splitLimit > 0 && total + inFlightMessageCount >= splitLimit)) {
                                                                return [2 /*return*/];
                                                            }
                                                            inFlightMessageCount += 1;
                                                            publishTopic = topicName;
                                                            publishMessage = message;
                                                            if (commandType === 'simulate') {
                                                                options.clientId = opts.clientId || options.clientId;
                                                                simulationResult = simulator.generator(options);
                                                                if (simulationResult.topic) {
                                                                    publishTopic = simulationResult.topic;
                                                                }
                                                                publishMessage = simulationResult.message;
                                                            }
                                                            if (fileRead) {
                                                                if (!split) {
                                                                    publishMessage = fileData;
                                                                }
                                                                else {
                                                                    if (dupSplitedMessageArr.length === 0) {
                                                                        return [2 /*return*/];
                                                                    }
                                                                    publishMessage = Buffer.from(dupSplitedMessageArr.shift());
                                                                }
                                                            }
                                                            client.publish(publishTopic, publishMessage, pubOpts.opts, function (err) {
                                                                inFlightMessageCount -= 1;
                                                                if (err) {
                                                                    logWrapper_1.basicLog.error(err);
                                                                }
                                                                else {
                                                                    total += 1;
                                                                    rate += 1;
                                                                }
                                                            });
                                                            return [2 /*return*/];
                                                    }
                                                });
                                            }); }, messageInterval);
                                            if (connectedCount === count) {
                                                initialized = true;
                                                var connEnd = Date.now();
                                                logWrapper_1.signale.success("Created ".concat(count, " connections in ").concat((connEnd - connStart) / 1000, "s"));
                                                if (!verbose) {
                                                    setInterval(function () {
                                                        interactivePub.log("Published total: ".concat(total, ", message rate: ").concat(rate, "/s"));
                                                        rate = 0;
                                                    }, 1000);
                                                }
                                                else {
                                                    setInterval(function () {
                                                        logWrapper_1.default.log("Published total: ".concat(total, ", message rate: ").concat(rate, "/s"));
                                                        rate = 0;
                                                    }, 1000);
                                                }
                                            }
                                        }
                                        else {
                                            logWrapper_1.benchLog.reconnected(connectedCount, count, opts.clientId);
                                        }
                                    });
                                    client.on('error', function (err) {
                                        logWrapper_1.benchLog.error(connectedCount, count, opts.clientId, err);
                                        client.end();
                                    });
                                    client.on('reconnect', function () {
                                        retryTimesArray[i - 1] += 1;
                                        if (retryTimesArray[i - 1] > maximumReconnectTimes) {
                                            client.end(false, {}, function () {
                                                logWrapper_1.benchLog.reconnectTimesLimit(connectedCount, count, opts.clientId);
                                                if (retryTimesArray.findIndex(function (times) { return times <= maximumReconnectTimes; }) === -1) {
                                                    process.exit(1);
                                                }
                                            });
                                        }
                                        else {
                                            logWrapper_1.benchLog.reconnecting(connectedCount, count, opts.clientId);
                                            isNewConnArray[i - 1] = false;
                                        }
                                    });
                                    client.on('close', function () {
                                        connectedCount > 0 && (connectedCount -= 1);
                                        logWrapper_1.benchLog.close(connectedCount, count, opts.clientId);
                                    });
                                    client.on('disconnect', function (packet) {
                                        logWrapper_1.basicLog.disconnect(packet, opts.clientId);
                                    });
                                })(i, connOpts);
                                return [4 /*yield*/, (0, delay_1.default)(interval)];
                            case 1:
                                _b.sent();
                                return [2 /*return*/];
                        }
                    });
                };
                i = 1;
                _a.label = 1;
            case 1:
                if (!(i <= count)) return [3 /*break*/, 4];
                return [5 /*yield**/, _loop_1(i)];
            case 2:
                _a.sent();
                _a.label = 3;
            case 3:
                i++;
                return [3 /*break*/, 1];
            case 4: return [2 /*return*/];
        }
    });
}); };
var benchPub = function (options) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        multiPub('benchPub', options);
        return [2 /*return*/];
    });
}); };
exports.benchPub = benchPub;
var simulatePub = function (options) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        multiPub('simulate', options);
        return [2 /*return*/];
    });
}); };
exports.simulatePub = simulatePub;
exports.default = pub;
