"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.jsonStringify = exports.jsonParse = void 0;
var JSONBigNumber = require('json-bigint');
var JSONBigInt = require('json-bigint')({ useNativeBigInt: true });
var jsonParse = function () {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    try {
        // When JSON only contains integers, use the native bigint type.
        return JSONBigInt.parse.apply(JSONBigInt, args);
    }
    catch (_a) {
        try {
            // When JSON contains floating-point numbers, use the bignumber library.
            // The numbers in the parsed JSON Object will be represented as BigNumber Objects.
            return JSONBigNumber.parse.apply(JSONBigNumber, args);
        }
        catch (_b) {
            // To verify the validity of the JSON string and throw an error if it's invalid.
            return JSON.parse(args[0], args[1]);
        }
    }
};
exports.jsonParse = jsonParse;
var jsonStringify = function () {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    try {
        // When JSON only contains integers, use the native bigint type.
        return JSONBigInt.stringify.apply(JSONBigInt, args);
    }
    catch (_error) {
        // When JSON contains floating-point numbers, use the bignumber library.
        // Integers will be represented in scientific notation.
        return JSONBigNumber.stringify.apply(JSONBigNumber, args);
    }
};
exports.jsonStringify = jsonStringify;
