"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformPBJSError = void 0;
/**
 * @reference https://github.com/spluxx/Protoman/blob/master/src/core/protobuf/pbjsErrors.ts
 */
function prepend(msg) {
    return "Message deserialization error: ".concat(msg);
}
function indexOutOfRange(msg) {
    function errMsg(pos, read, len) {
        return "Index out of range: the reader was at position ".concat(pos, " and tried to read ").concat(read, " more (bytes), but the given buffer was ").concat(len, " bytes");
    }
    var regex = /index out of range: ([0-9]+) \+ ([0-9]+) > ([0-9]+)/;
    var res = msg.match(regex);
    if (res) {
        var matched = res[0], pos = res[1], read = res[2], len = res[3];
        return msg.replace(matched, errMsg(pos, read, len));
    }
    return msg;
}
function transformPBJSError(e) {
    var transformers = [prepend, indexOutOfRange];
    var message = transformers.reduce(function (msg, transform) { return transform(msg); }, e.message);
    return new Error(message);
}
exports.transformPBJSError = transformPBJSError;
